<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>无因汇入提交接口/Remittance With No Reason Submitting Interface</title>
</head>

<body>
<?php 

		$merchantId=$_POST["merchantId"];
		$requestId=$_POST["requestId"];
		$amount=$_POST["amount"];
		$currency=$_POST["currency"];
		$notifyUrl=$_POST["notifyUrl"];
		$tradePostscript=$_POST["tradePostscript"];
		$sourceCountry=$_POST["sourceCountry"];
		$fundPurpose=$_POST["fundPurpose"];
		
		$payee=array();
		$payee["name"]=$_POST["payee_name"];
		$payee["nameZh"]=$_POST["payee_nameZh"];
		$payee["swiftCode"]=$_POST["payee_swiftCode"];
		$payee["idType"]=$_POST["payee_idType"];
		$payee["idNum"]=$_POST["payee_idNum"];
		$payee["phoneNum"]=$_POST["payee_phoneNum"];
		$payee["bankCardNum"]=$_POST["payee_bankCardNum"];
		$payee["bankName"]=$_POST["payee_bankName"];
		$payee["bankAddress"]=$_POST["payee_bankAddress"];
		$payee["bankCity"]=$_POST["payee_bankCity"];
		
		$payer=array();
		$payer["name"]=$_POST["payer_name"];
		$payer["idType"]=$_POST["payer_idType"];
		$payer["idNum"]=$_POST["payer_idNum"];
		$payer["bankCardNum"]=$_POST["payer_bankCardNum"];
		$payer["payerCountry"]=$_POST["payer_payerCountry"];
		$payer["address"]=$_POST["payer_address"];
		$payer["birthday"]=$_POST["payer_birthday"];
		$payer["swiftCode"]=$_POST["payer_swiftCode"];
		$payer["bankName"]=$_POST["payer_bankName"];
		$payer["bankAddress"]=$_POST["payer_bankAddress"];
		$payer["bankCity"]=$_POST["payer_bankCity"];
		
		
		$json_arr=array();
		$json_arr["merchantId"]=$merchantId;
		$json_arr["requestId"]=$requestId;
		$json_arr["amount"]=$amount;
		$json_arr["currency"]=$currency;
		$json_arr["notifyUrl"]=$notifyUrl;
		$json_arr["tradePostscript"]=$tradePostscript;
		$json_arr["sourceCountry"]=$sourceCountry;
		$json_arr["payee"]=$payee;
		$json_arr["payer"]=$payer;
		$json_arr["fundPurpose"]=$fundPurpose;
		
		$data = array();
			foreach($json_arr as $k=>$var){ 
				if(is_scalar($var) && $var !== '' && $var !== null){//如果给出的变量参数 var 是一个标量，is_scalar() 返回 TRUE，否则返回 FALSE。标量变量是指那些包含了 integer、float、string 或 boolean的变量，而 array、object 和 resource 则不是标量。
						$data[$k] = $var;
				}else if(is_object($var)){
						$data[$k] =array_filter((array) $var);
				}else if(is_array($var)){
						$data[$k] =array_filter($var);
				}
				if(empty($data[$k])){
					unset($data[$k]);
				}
			}//foreach -end
			
			
			ksort($data);
$hmacSource = '';
foreach($data as $key => $value){
    if (is_array($value)) {
        ksort($value);
        foreach ($value as $key2 => $value2) {

            if (is_object($value2)) {
                $value2 = array_filter((array)$value2);
                ksort($value2);
                foreach ($value2 as $oKey => $oValue) {
                    $oValue .= '#';
                    $hmacSource .= trim($oValue);

                }
            } else if(is_array($value2)){
                ksort($value2);
                foreach ($value2 as $key3 => $value3) {
                    if (is_object($value3)) {
                        $value3 = array_filter((array)$value3);
                        ksort($value3);
                        foreach ($value3 as $oKey => $oValue) {
                            $oValue .= '#';
                            $hmacSource .= trim($oValue);
                        }
                    } else{
                        $value3 .= '#';
                        $hmacSource .= trim($value3);
                    }
                }
            } else{
                $value2 .= '#';
                $hmacSource .= trim($value2);
            }
        }
    } else {
        $value .= '#';
        $hmacSource .= trim($value);
    }
}

			
		$sha1mac=sha1($hmacSource,true);
		
		$pubKey = file_get_contents('client.pfx');
		$results=array();
		$worked=openssl_pkcs12_read($pubKey,$results,'123456');
		$rs=openssl_sign($sha1mac,$hmac,$results['pkey'],"md5");
		//echo $hmac=bin2hex($hmac);
		$hmac=base64_encode($hmac);
		//echo "<br>";
		
		
		$hmacarr=array();
		$hmacarr["hmac"]=$hmac;
		
		$arr_t=(array_merge($json_arr,$hmacarr));
		//$json_str=json_encode($arr_t);
		/*$json_str=json_encode($arr_t,JSON_UNESCAPED_SLASHES);//去掉转移字符
		$json_str=json_encode($arr_t, JSON_UNESCAPED_UNICODE); //正常输出中文*/
		//echo $json_str=json_encode($arr_t, JSON_NUMERIC_CHECK); //正常输出数字 字符串转数字
		//echo "4321<br>";
		$json_str=json_encode($arr_t,JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
		
###############AES#####################请求体
		
		 /*
          * 生成16位随机数（AES秘钥）
          */
        $str1='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890';
        $randStr = str_shuffle($str1);//打乱字符串
        $rands= substr($randStr,0,16);
		
		//AES加密JSON串
        $screct_key = $rands; 
        $str = trim($json_str);
        $str = addPKCS7Padding($str);
        $encrypt_str= openssl_encrypt($str, 'AES-128-ECB', $screct_key, OPENSSL_RAW_DATA|OPENSSL_ZERO_PADDING);
        $date = base64_encode($encrypt_str);
		
		 /**
     * 填充算法
     * @param string $source
     * @return string
     */
    function addPKCS7Padding($string, $blocksize = 16) { 
        $len = strlen($string);
        $pad = $blocksize - ($len % $blocksize);
        $string .= str_repeat(chr($pad), $pad);
        return $string;

    }

		/*$json_arr_aes=array();
		$json_arr_aes["data"]=$date;
		
		$json_str_data=json_encode($json_arr_aes);*/
		
###############AES#####################

	
	$verifyKey4Server = file_get_contents('test.cer');  
  	$pem = chunk_split(base64_encode($verifyKey4Server),64,"\n");//转换为pem格式的公钥  
    $public_key = "-----BEGIN CERTIFICATE-----\n".$pem."-----END CERTIFICATE-----\n";
	$pu_key =  openssl_pkey_get_public($public_key);//这个函数可用来判断公钥是否是可用的
	openssl_public_encrypt($rands,$encryptKey,$pu_key);//公钥加密
	$encryptKey = base64_encode($encryptKey);
	

	$url = "https://apis.geoswift.com/remittance/order";
	
		$curl = curl_init($url);
        curl_setopt($curl,CURLOPT_HEADER, 1 ); // 过滤HTTP头
        curl_setopt($curl,CURLOPT_HTTPHEADER,array(
            'Content-Type: application/vnd.geoswift-v3.0+json',
			'encryptKey: '.$encryptKey,
            'merchantId: '.$merchantId,
            'requestId: '.$requestId
        ));
        curl_setopt($curl,CURLOPT_RETURNTRANSFER, 1);// 显示输出结果
        curl_setopt($curl,CURLOPT_POST,true); // post传输数据
        curl_setopt($curl,CURLOPT_POSTFIELDS,$date);// post传输数据
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);//SSL证书认证
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);//严格认证

     $responseText = curl_exec($curl);
	
	
        if (curl_errno($curl) || $responseText === false) {
            curl_close($curl);
            throw new InvalidRequestException(array(
                'error_description'=> 'Request Error'
            ));
        }
        curl_close($curl);
		
		preg_match_all('/(encryptKey|merchantId|data"):(\s+|")([^"\s]+)/s',$responseText,$m);
		if(count($m[3])<3){
			preg_match_all('/(encryptkey|merchantid|data"):(\s+|")([^"\s]+)/s',$responseText,$m);
		}
        list($encryptKey, $merchantId, $data) = $m[3];
        $responsedata = array("data" =>$data,"encryptKey"=>$encryptKey,"merchantId"=>$merchantId);
		
	
	$encryptKey =$responsedata['encryptKey'];	
	$pubKey = file_get_contents('client.pfx');
	$results=array();
	$worked=openssl_pkcs12_read($pubKey,$results,'123456');
	$private_key=$results['pkey'];
	$pi_key =  openssl_pkey_get_private($private_key);//这个函数可用来判断私钥是否是可用的，可用返回资源id Resource id
	openssl_private_decrypt(base64_decode($encryptKey),$decrypted,$pi_key);//私钥解密
	//echo $decrypted,"\n";
		
	$responsedatadata=$responsedata['data'];
		//echo "<br>";
		
		$date = base64_decode($responsedatadata);
		
		$screct_key = $decrypted;
      	$encrypt_str=  openssl_decrypt($responsedatadata,"AES-128-ECB",$screct_key);
        $encrypt_str = preg_replace('/[\x00-\x1F]/','', $encrypt_str);
        $encrypt_str = json_decode($encrypt_str,true);
		
		
		/*
         * 去除空值的元素
         */

        function clearBlank($arr)
        {
            function odd($var)
            {
                return($var<>'');//return true or false
            }
            return (array_filter($arr, "odd"));
        }

        function array_remove_empty(& $arr, $trim = true){
            foreach ($arr as $key => $value) {
                if (is_array($value)) {
                    array_remove_empty($arr[$key]);
                } else {
                    $value = trim($value);
                    if ($value == '') {
                        unset($arr[$key]);
                    } elseif ($trim) {
                        $arr[$key] = $value;
                    }
                }
            }
        }
        $encrypt_str = clearBlank($encrypt_str);
	
	print_r($encrypt_str);
	echo "<br>";
	$hmac = $encrypt_str['hmac'];
	unset($encrypt_str['hmac']); //去除数组的一个hmac元素
    ksort($encrypt_str);
	
	$hmacSource2 = '';
	
		foreach($encrypt_str as $key => $value){
		if (is_array($value)) {
			ksort($value);
			$value=array_filter($value);
			foreach ($value as $key2 => $value2) {
	
				if (is_object($value2)) {
					$value2 = array_filter((array)$value2);
					ksort($value2);
					foreach ($value2 as $oKey => $oValue) {
						$oValue .= '#';
						$hmacSource2 .= trim($oValue);
	
					}
				} else if(is_array($value2)){
					ksort($value2);
					foreach ($value2 as $key3 => $value3) {
						if (is_object($value3)) {
							$value3 = array_filter((array)$value3);
							ksort($value3);
							$value3=clearBlank($value3);
							foreach ($value3 as $oKey => $oValue) {
								$oValue .= '#';
								$hmacSource2 .= trim($oValue);
							}
						} else{
							$value3 .= '#';
							$hmacSource2 .= trim($value3);
						}
					}
				} else{
					$value2 .= '#';
					$hmacSource2 .= trim($value2);
				}
			}
		} else {
			$value .= '#';
			$hmacSource2 .= trim($value);
		}
	}
	
        
		$sha1mac2=sha1($hmacSource2,true);
		
		$verifyKeyPath="test.cer";      
        $verifyKey4Server = file_get_contents($verifyKeyPath);  
  		$pem = chunk_split(base64_encode($verifyKey4Server),64,"\n");//转换为pem格式的公钥  
        $pem = "-----BEGIN CERTIFICATE-----\n".$pem."-----END CERTIFICATE-----\n";  
		echo $keyid = openssl_pkey_get_public($pem);  
		echo "<br>";
	
	$verify = openssl_verify($sha1mac2,base64_decode($hmac),$keyid,OPENSSL_ALGO_MD5);
	//var_dump($verify);
	//echo "<br>";

	if($verify===1){
		echo "CFCA验证成功";
		
	}else{
		echo "CFCA验证失败";
	}
?>
</body>
</html>